"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _camelcase = _interopRequireDefault(require("camelcase"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var camelizeKeys = function camelizeKeys(obj) {
  var copy = {};

  for (var key in obj) {
    copy[(0, _camelcase["default"])(key)] = obj[key];
  }

  return copy;
};

var isObject = function isObject(data) {
  return _typeof(data) === 'object' && data !== null;
};

var defaultOptions = {
  camleCaseKeys: true
};

var FlatJsonApiNormalizr =
/*#__PURE__*/
function () {
  function FlatJsonApiNormalizr(options) {
    _classCallCheck(this, FlatJsonApiNormalizr);

    this.options = _objectSpread({}, defaultOptions, options);
    this.error = 'invalid json';
  }

  _createClass(FlatJsonApiNormalizr, [{
    key: "normalize",
    value: function normalize(json) {
      if (!isObject(json)) {
        console.error(this.error); // eslint-disable-line no-console

        return {};
      }

      var _json$data = json.data,
          data = _json$data === void 0 ? {} : _json$data,
          _json$included = json.included,
          included = _json$included === void 0 ? [] : _json$included,
          meta = json.meta,
          jsonapi = json.jsonapi,
          links = json.links,
          errors = json.errors;
      this.formatedData = {};
      this.includedData = included;

      try {
        this.parseData(data);
      } catch (error) {
        console.error(this.error, error); // eslint-disable-line no-console

        return {};
      }

      return _objectSpread({
        jsonapi: jsonapi,
        links: links,
        errors: errors
      }, this.formatedData, meta && {
        meta: this.options.camleCaseKeys ? camelizeKeys(meta) : meta
      });
    }
  }, {
    key: "parseData",
    value: function parseData(data, isRelation) {
      var _this = this;

      var relationshipsData = {};
      var dataArr = Array.isArray(data) ? data : [data];
      dataArr.forEach(function (el) {
        var elementType = (0, _camelcase["default"])(el.type);

        var element = _objectSpread({}, el, _this.getElementIncluded(el));

        var formatedElement = _objectSpread({}, _this.getElementMainData(element), element.relationships ? {
          relationships: _this.getElementRelationships(element)
        } : null);

        if (isRelation) {
          _this.pushDataForRelation(relationshipsData, elementType, element);
        }

        _this.addElementToFormatedData(elementType, formatedElement);
      });

      if (isRelation) {
        return relationshipsData;
      }
    }
  }, {
    key: "getElementMainData",
    value: function getElementMainData(el) {
      var attributes = el.attributes,
          props = _objectWithoutProperties(el, ["attributes"]);

      return _objectSpread({}, props, attributes && {
        attributes: this.options.camleCaseKeys ? camelizeKeys(attributes) : attributes
      });
    }
  }, {
    key: "getElementIncluded",
    value: function getElementIncluded(el) {
      return this.includedData.find(function (includedEl) {
        return includedEl.type === el.type && includedEl.id === el.id;
      });
    }
  }, {
    key: "getElementRelationships",
    value: function getElementRelationships(el) {
      var relationships = el.relationships;
      if (!relationships) return null;
      var formatedData = {};

      for (var relationKey in relationships) {
        var relation = relationships[relationKey].data;
        formatedData = _objectSpread({}, formatedData, relation ? this.parseData(relation, true) : null);
      }

      return formatedData;
    }
  }, {
    key: "addElementToFormatedData",
    value: function addElementToFormatedData(key, el) {
      if (!this.formatedData[key]) {
        this.formatedData[key] = {};
      }

      this.formatedData[key][el.id] = el;
    }
  }, {
    key: "pushDataForRelation",
    value: function pushDataForRelation(obj, key, el) {
      var id = el.id,
          type = el.type;

      if (!obj[key]) {
        obj[key] = [];
      }

      obj[key].push({
        id: id,
        type: type
      });
      return obj;
    }
  }]);

  return FlatJsonApiNormalizr;
}();

exports["default"] = FlatJsonApiNormalizr;